import { SlashCommandBuilder } from '@discordjs/builders';
import { CommandInteraction, GuildMember } from 'discord.js';
import { changeCounterInteraction } from '../lib/counter';

module.exports = {
  data: new SlashCommandBuilder()
    .setName('increase')
    .setDescription('Increase the counter')
    .addIntegerOption((option) =>
      option
        .setName('amount')
        .setRequired(false)
        .setDescription('Amount to increase the counter by')
        .setMinValue(1)
    ),

  execute: async (interaction: CommandInteraction, member: GuildMember) => {
    await interaction.deferReply({ephemeral: true});
    const amount = Math.trunc(interaction.options.getInteger('amount') || 1);
    changeCounterInteraction(interaction, member, amount);
  }
};